package examples.ch25;

import classUtils.dumper.ClassFile;
import futils.DirList;

import java.io.File;

/**
 * DocJava, Inc.
 * http://www.docjava.com
 * Programmer: dlyon
 * Date: Sep 29, 2004
 * Time: 9:05:56 PM
 */
public class MainUtils {
    public static void main(String[] args) {
        try {
            DirList dl = new DirList(".class");
            File fa[] = dl.getFilesNotDirectories();
            for (int i = 0; i < fa.length; i++) {
                processClass(fa[i]);
            }
            // 1a.  Convert a class file into a Class.
            // 1b. convert the list of files into a list of classes.
            // 2. print out only those classes that contain a
            //    public static void main(String args[]) method.
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }

    private static void processClass(File f) throws ClassNotFoundException {
        ClassFile cf = ClassFile.getClassFile(f);
        String cn = cf.getClassName();
        Class c = Class.forName(cn);
        System.out.println(cn);
    }
}
